> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pdf.co/llms.txt
> Use this file to discover all available pages before exploring further.

# PDF from HTML Template

> Convert `HTML` template into `PDF`.

## `POST /v1/pdf/convert/from/html`

<Info>
  Converts a predefined [HTML template](#html-templates) into a PDF document using its Template ID. The template must be created and saved in the [HTML to PDF Templates](https://app.pdf.co/html-templates-tool/manager) section of the dashboard.
</Info>

## Attributes

<Note>Attributes are case-sensitive and should be inside JSON for POST request. for example: `{ "url": "https://example.com/file1.pdf" }`</Note>

<Note>Remember to ensure that request sizes are less than `4` mb in file size. For more information, see [Request Size Limits](/api-reference/url-input-and-request-limits#pdf-co-request-size).</Note>

| Attribute                     | Type    | Required | Default  | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| ----------------------------- | ------- | -------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `templateId`                  | integer | *Yes*    | -        | Set ID of HTML template to be used. View and manage your templates at HTML to PDF Templates.                                                                                                                                                                                                                                                                                                                                                                                            |
| `templateData`                | string  | *Yes*    | -        | Set it to a string with input `JSON` data (recommended) or `CSV` data. See [Sample JSON input](#sample-json-input) and [Sample CSV input](#sample-csv-input) for more information.                                                                                                                                                                                                                                                                                                      |
| `callback`                    | string  | *No*     | -        | The callback URL (or Webhook) used to receive the POST data. see [Webhooks & Callbacks](/api-reference/webhooks). This is only applicable when `async` is set to `true`.                                                                                                                                                                                                                                                                                                                |
| `margins`                     | string  | *No*     | -        | Set custom margins, overriding CSS default margins. Specify the margins in the format `{top} {right} {bottom} {left}`. You can use`px`,`mm`,`cm`or`in`units. Also, you can set margins for all sides at once using a single value.                                                                                                                                                                                                                                                      |
| `paperSize`                   | string  | *No*     | A4       | Specifies the paper size. Accepts standard sizes like 'Letter', 'Legal', 'Tabloid', 'Ledger', 'A0'–'A6'. You can also set a custom size by providing width and height separated by a space, with optional units: `px` (pixels), `mm` (millimeters), `cm` (centimeters), or `in` (inches). Examples: '200 300', '200px 300px', '200mm 300mm', '20cm 30cm', '6in 8in'.                                                                                                                    |
| `orientation`                 | string  | *No*     | Portrait | Sets the document orientation. Options: `Portrait` for vertical layout, and `Landscape` for horizontal layout.                                                                                                                                                                                                                                                                                                                                                                          |
| `printBackground`             | boolean | *No*     | `true`   | Set to `false` to disable background colors and images are included when generating PDFs from HTML/URL                                                                                                                                                                                                                                                                                                                                                                                  |
| `mediaType`                   | string  | *No*     | print    | Controls how content is rendered when converting to PDF. Options: `print` (uses print styles), `screen` (uses screen styles), `none` (no media type applied).                                                                                                                                                                                                                                                                                                                           |
| `DoNotWaitFullLoad`           | boolean | *No*     | `false`  | Controls how thoroughly the converter waits for a page to load before converting HTML to PDF --- false waits for full page load, while true speeds up conversion by waiting only for minimal loading.                                                                                                                                                                                                                                                                                   |
| `header`                      | string  | *No*     | -        | Set this to can add user definable HTML for the header to be applied on every page header. The format is html.                                                                                                                                                                                                                                                                                                                                                                          |
| `footer`                      | string  | *No*     | -        | Set this to can add user definable HTML for the footer to be applied on every page bottom. The format is html.                                                                                                                                                                                                                                                                                                                                                                          |
| `async`                       | boolean | *No*     | `false`  | Set `async` to `true` for long processes to run in the background, API will then return a `jobId` which you can use with the [Background Job Check endpoint](/api-reference/job-check). Also see [Webhooks & Callbacks](/api-reference/webhooks)                                                                                                                                                                                                                                        |
| `name`                        | string  | *No*     | -        | File name for the generated output, the input must be in string format.                                                                                                                                                                                                                                                                                                                                                                                                                 |
| `expiration`                  | integer | *No*     | `60`     | Set the expiration time for the output link in minutes. After this specified duration, any generated output file(s) will be automatically deleted from [PDF.co Temporary Files Storage](/api-reference/file-upload/overview). The maximum duration for link expiration varies based on your current subscription plan. To store permanent input files (e.g. re-usable images, pdf templates, documents) consider using [PDF.co Built-In Files Storage](https://app.pdf.co/tools/files). |
| `profiles`                    | object  | *No*     | -        | See [Profiles](/api-reference/profiles) for more information.                                                                                                                                                                                                                                                                                                                                                                                                                           |
|     `outputDataFormat`        | string  | *No*     | -        | If you require your output as `base64` format, set this to `base64`                                                                                                                                                                                                                                                                                                                                                                                                                     |
|     `DataEncryptionAlgorithm` | string  | *No*     | -        | Controls the encryption algorithm used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                                                                                                                                                                                                                                                               |
|     `DataEncryptionKey`       | string  | *No*     | -        | Controls the encryption key used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                 |
|     `DataEncryptionIV`        | string  | *No*     | -        | Controls the encryption IV used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                  |
|     `DataDecryptionAlgorithm` | string  | *No*     | -        | Controls the decryption algorithm used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                                                                                                                                                                                                                                                               |
|     `DataDecryptionKey`       | string  | *No*     | -        | Controls the decryption key used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                 |
|     `DataDecryptionIV`        | string  | *No*     | -        | Controls the decryption IV used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                  |

## HTML Templates

<Warning>
  During conversion, the API performs variable substitution and built-in helper evaluation using your [templateData](#html-templates), but does not execute any arbitrary JavaScript within the template itself. After the template is rendered into HTML, a headless browser processes the page and executes any in-page JavaScript triggered on load. External or dynamically loaded JavaScript libraries may run if accessible, but execution is not guaranteed in all environments. This separation ensures secure, predictable template handling and accurate rendering of interactive web content.
</Warning>

Use the dashboard to manage your HTML to [PDF Templates](https://app.pdf.co/html-templates-tool).

Templates use `{{Mustache}}` and Handlebars templating syntax. You just need to insert macros surrounded by double brackets like `{{` and `}}`.

* Find out more about [Mustache](https://mustache.github.io/mustache.5.html).

* Find out more about [Handlebars](https://handlebarsjs.com/guide/).

Some Examples of macro inside html template:

* `{{variable1}}` will be replaced with `test` if you set `templateData` to `{ "variable1": "test" }`
* `{{object1.variable1}}` will be replaced with `test` if you set `templateData` to `{ "object1": { "variable1": "test" } }`
* Simple conditions are also supported. For example: `{{#if paid}} invoice was paid {{/if}}` will show invoice was paid when `templateData` is set to `{ "paid": true }`.

### Handlebars

Handlebars extends Mustache with powerful features like conditional logic, loops, and custom helper functions. You can use Handlebars helpers like `#if`, `#unless`, `#each` (see [https://handlebarsjs.com/guide/builtin-helpers.html](https://handlebarsjs.com/guide/builtin-helpers.html)) but you can also define your own helper functions for complex calculations and data manipulation.

#### Key Handlebars Features:

* **Variable substitution**: `{{variable}}` syntax for inserting data
* **Conditional logic**: `{{#if}}` and `{{#unless}}` blocks for conditional rendering
* **Loops**: `{{#each}}` for iterating over arrays and objects
* **Nested objects**: Accessing properties with dot notation like `{{company.name}}`
* **Built-in helpers**: Using Handlebars' built-in functionality for common operations

### Sample JSON input

```json theme={null}
"templateData": "{ 'paid': true, 'invoice_id': '0002', 'total': '$999.99' }"
```

<Note>If you use `JSON` as input then make sure to escape it first (with `JSON.stringify(dataObject)` in JS). Escaping is when every `"` is replaced with `\"`. Example with `"` be escaped as `\"` then: `"templateData": "{ \"paid\": true, \"invoice_id\": \"0002\", \"total\": \"$999.99\" }"`.</Note>

### Sample CSV input

```csv theme={null}
"templateData": "paid,invoice_id,total
true,0002,$999.99"
```

## Header & Footer

The `header` and `footer` parameters can contain valid HTML markup with the following classes used to inject printing values into them:

* `date`: formatted print date
* `title`: document title
* `url`: document location
* `pageNumber`: current page number
* `totalPages`: total pages in the document

img: tag is supported in both the header and footer parameter, provided that the `src` attribute is specified as a `base64-encoded` string.

For example, the following markup will generate `Page N of NN` page numbering:

```html theme={null}
<span style='font-size:10px'>Page <span class='pageNumber'></span> of <span class='totalPages'></span>.</span>
```

### Sample Header & Footer

An example with an advanced `header` and `footer`. Note that the top and bottom page margins are important because page content may overlap the footer or header.

```json theme={null}
{
    "templateId": 1,
    "name": "newDocument.pdf",
    "mediaType": "print",
    "margins": "40px 20px 20px 20px",
    "paperSize": "Letter",
    "orientation": "Portrait",
    "printBackground": true,
    "header": "<div style='width:100%'><span style='font-size:10px;margin-left:20px;width:50%;float:left'>LEFT SUBHEADER</span><span style='font-size:8px;width:30%;float:right'>RIGHT SUBHEADER</span></div>",
    "footer": "<div style='width:100%;text-align:right'><span style='font-size:10px;margin-right:20px'>Page <span class='pageNumber'></span> of <span class='totalPages'></span>.</span></div>",
    "async": false,
    "templateData": "{\"paid\": true,\"invoice_id\": \"0021\",\"invoice_date\": \"August 29, 2041\",\"invoice_dateDue\": \"September 29, 2041\",\"issuer_name\": \"Sarah Connor\",\"issuer_company\": \"T-800 Research Lab\",\"issuer_address\": \"435 South La Fayette Park Place, Los Angeles, CA 90057\",\"issuer_website\": \"www.example.com\",\"issuer_email\": \"info@example.com\",\"client_name\": \"Cyberdyne Systems\",\"client_company\": \"Cyberdyne Systems\",\"client_address\": \"18144 El Camino Real, Sunnyvale, California\",\"client_email\": \"sales@example.com\",\"items\": [    {    \"name\": \"T-800 Prototype Research\",    \"price\": 1000.00    },    {    \"name\": \"T-800 Cloud Sync Setup\",    \"price\": 300.00    }  ],\"discount\": 100,\"tax\": 87,\"total\": 1287,\"note\": \"Thank you for your support of advanced robotics.\"}"
}
```

## Query parameters

*No query parameters accepted.*

## Responses

| Parameter             | Type    | Description                                                                                                                  |
| --------------------- | ------- | ---------------------------------------------------------------------------------------------------------------------------- |
| `url`                 | string  | Direct URL to the final PDF file stored in S3.                                                                               |
| `outputLinkValidTill` | string  | Timestamp indicating when the output link will expire                                                                        |
| `pageCount`           | integer | Number of pages in the PDF document.                                                                                         |
| `error`               | boolean | Indicates whether an error occurred (`false` means success)                                                                  |
| `status`              | string  | Status code of the request (200, 404, 500, etc.). For more information, see [Response Codes](/api-reference/response-codes). |
| `name`                | string  | Name of the output file                                                                                                      |
| `credits`             | integer | Number of credits consumed by the request                                                                                    |
| `remainingCredits`    | integer | Number of credits remaining in the account                                                                                   |
| `duration`            | integer | Time taken for the operation in milliseconds                                                                                 |

## `Example` Payload

<Note>To see the request size limits, please refer to the [Request Size Limits](/api-reference/url-input-and-request-limits#pdf-co-request-size).</Note>

```json theme={null}
{
    "templateId": 1,
    "name": "newDocument.pdf",
    "mediaType": "print",
    "margins": "40px 20px 20px 20px",
    "paperSize": "Letter",
    "orientation": "Portrait",
    "printBackground": true,
    "header": "",
    "footer": "",
    "async": false,
    "templateData": "{\"paid\": true,\"invoice_id\": \"0021\",\"invoice_date\": \"August 29, 2041\",\"invoice_dateDue\": \"September 29, 2041\",\"issuer_name\": \"Sarah Connor\",\"issuer_company\": \"T-800 Research Lab\",\"issuer_address\": \"435 South La Fayette Park Place, Los Angeles, CA 90057\",\"issuer_website\": \"www.example.com\",\"issuer_email\": \"info@example.com\",\"client_name\": \"Cyberdyne Systems\",\"client_company\": \"Cyberdyne Systems\",\"client_address\": \"18144 El Camino Real, Sunnyvale, California\",\"client_email\": \"sales@example.com\",\"items\": [    {    \"name\": \"T-800 Prototype Research\",    \"price\": 1000.00    },    {    \"name\": \"T-800 Cloud Sync Setup\",    \"price\": 300.00    }  ],\"discount\": 100,\"tax\": 87,\"total\": 1287,\"note\": \"Thank you for your support of advanced robotics.\"}"
}
```

## `Example` Response

<Note>To see the main response codes, please refer to the [Response Codes](/api-reference/response-codes) page.</Note>

```json theme={null}
{
  "url": "https://pdf-temp-files.s3.amazonaws.com/97dc323f32794eae8fa6602f5bd981c1/result.pdf",
  "pageCount": 1,
  "error": false,
  "status": 200,
  "name": "result.pdf",
  "remainingCredits": 60646
}
```

<Note>
  **Inconsistent URL Encoding in cURL Output:** When using cURL to make API requests, the output JSON may show URL characters encoded as Unicode escape sequences. For example, the ampersand character (`&`) may appear as `\u0026` in the cURL output. This is normal JSON encoding behavior and does not affect the validity of the URL. The URL will function correctly when used, as JSON parsers automatically decode these escape sequences. If you're parsing the response programmatically, your JSON parser will handle this conversion automatically.
</Note>

## Code Samples

<Tabs>
  <Tab title="CURL">
    ```bash theme={null}
    curl --location --request POST 'https://api.pdf.co/v1/pdf/convert/from/html' \
    --header 'x-api-key: add_your_api_key_here' \
    --header 'Content-Type: application/json' \
    --data-raw '{
        "templateId": 2,
        "name": "newDocument.pdf",
        "margins": "40px 20px 20px 20px",
        "paperSize": "Letter",
        "orientation": "Portrait",
        "printBackground": true,
        "header": "",
        "footer": "",
        "async": false,
        "encrypt": false,
        "templateData": "{\"invoice_id\":\"1234567\",\"invoice_date\":\"April 30, 2016\",\"invoice_dateDue\":\"May 15, 2016\",\"paid\":false,\"issuer_name\":\"Acme Inc\",\"issuer_company\":\"Acme International\",\"issuer_address\":\"City, Street 3rd\",\"issuer_email\":\"support@example.com\",\"issuer_website\":\"http://example.com\",\"client_name\":\"Food Delivery Inc.\",\"client_company\":\"Food Delivery International\",\"client_address\":\"New York, Some Street, 42\",\"client_email\":\"client@example.com\",\"items\":[{\"name\":\"Setting up new web-site\",\"price\":250},{\"name\":\"Website Content Addition\",\"price\":700},{\"name\":\"Database Setup\",\"price\":200},{\"name\":\"Record Digitalization\",\"price\":1800},{\"name\":\"Cloud Storage\",\"price\":500},{\"name\":\"Short Messages\",\"price\":35},{\"name\":\"Search Engine Optimization\",\"price\":200},{\"name\":\"Priority Support\",\"price\":75},{\"name\":\"Configuring mail server and mailboxes\",\"price\":50}],\"tax\":0.065,\"discount\":0.01,\"note\":\"Thank You For Your Business!\"}"
    }'
    ```
  </Tab>

  <Tab title="JavaScript/Node.js">
    ```javascript theme={null}
    var https = require("https");
    var path = require("path");
    var fs = require("fs");


    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    const API_KEY = "***********************************";


    // Data to fill the template
    const templateData = "./invoice_data.json";
    // Destination PDF file name
    const DestinationFile = "./result.pdf";

    /* 
    Please follow below steps to create your own HTML Template and get "templateId". 
    1. Add new html template in app.pdf.co/templates/html
    2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/bytescout/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
    3. Save this new template
    4. Copy it’s ID to clipboard
    5. Now set ID of the template into “templateId” parameter
    */

    // HTML template using built-in template
    // see https://app.pdf.co/templates/html/2/edit
    const template_id = 2;


    // Prepare request to `HTML To PDF` API endpoint
    var queryPath = `/v1/pdf/convert/from/html?name=${path.basename(DestinationFile)}&async=True`;
    var reqOptions = {
        host: "api.pdf.co",
        path: encodeURI(queryPath),
        method: "POST",
        headers: {
            "x-api-key": API_KEY,
            "Content-Type": "application/json"
        }
    };


    var requestBody = JSON.stringify({
        "templateId": template_id,
        "templateData": fs.readFileSync(templateData, "utf8"),
        "async": true
    });
    // Send request
    var postRequest = https.request(reqOptions, (response) => {
        response.on("data", (d) => {
            // Parse JSON response
            var data = JSON.parse(d);        
            if (data.error == false) {
                console.log(`Job #${data.jobId} has been created!`);
                checkIfJobIsCompleted(data.jobId, data.url);
            }
            else {
                // Service reported error
                console.log(data.message);
            }
        });
    }).on("error", (e) => {
        // Request error
        console.log(e);
    });

    // Write request data
    postRequest.write(requestBody);
    postRequest.end();


    function checkIfJobIsCompleted(jobId, resultFileUrl) {
        let queryPath = `/v1/job/check`;

        // JSON payload for api request
        let jsonPayload = JSON.stringify({
            jobid: jobId
        });

        let reqOptions = {
            host: "api.pdf.co",
            path: queryPath,
            method: "POST",
            headers: {
                "x-api-key": API_KEY,
                "Content-Type": "application/json",
                "Content-Length": Buffer.byteLength(jsonPayload, 'utf8')
            }
        };

        // Send request
        var postRequest = https.request(reqOptions, (response) => {
            response.on("data", (d) => {
                response.setEncoding("utf8");

                // Parse JSON response
                let data = JSON.parse(d);
                console.log(`Checking Job #${jobId}, Status: ${data.status}, Time: ${new Date().toLocaleString()}`);

                if (data.status == "working") {
                    // Check again after 3 seconds
    				setTimeout(function(){ checkIfJobIsCompleted(jobId, resultFileUrl);}, 3000);
                }
                else if (data.status == "success") {
                    // Download PDF file
                    var file = fs.createWriteStream(DestinationFile);
                    https.get(resultFileUrl, (response2) => {
                        response2.pipe(file)
                            .on("close", () => {
                                console.log(`Generated PDF file saved as "${DestinationFile}" file.`);
                            });
                    });
                }
                else {
                    console.log(`Operation ended with status: "${data.status}".`);
                }
            })
        });
        
        // Write request data
        postRequest.write(jsonPayload);
        postRequest.end();
    }
    ```
  </Tab>

  <Tab title="Python">
    ```python theme={null}
    import os
    import requests # pip install requests

    # The authentication key (API Key).
    # Get your own by registering at https://app.pdf.co
    API_KEY = "***********************************************"

    # Base URL for PDF.co Web API requests
    BASE_URL = "https://api.pdf.co/v1"

    # --HTML Template ID--
    # Please follow below steps to create your own HTML Template and get "templateId". 
    # 1. Add new html template in app.pdf.co/templates/html
    # 2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/bytescout/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
    # 3. Save this new template
    # 4. Copy it’s ID to clipboard
    # 5. Now set ID of the template into “templateId” parameter

    # HTML template using built-in template
    # see https://app.pdf.co/templates/html/2/edit
    template_id = 2


    # Data to fill the template
    file_read = open(".\\invoice_data.json", mode='r')
    TemplateData = file_read.read()
    file_read.close()

    # Destination PDF file name
    DestinationFile = ".\\result.pdf"


    def main(args = None):
        GeneratePDFFromTemplate(template_id, TemplateData, DestinationFile)


    def GeneratePDFFromTemplate(template_id, templateData, destinationFile):
        """Converts HTML to PDF using PDF.co Web API"""

        data = {
            'templateData': templateData,
            'templateId': template_id
        }

        # Prepare URL for 'HTML To PDF' API request
        url = "{}/pdf/convert/from/html?name={}".format(
            BASE_URL,
            os.path.basename(destinationFile)
        )

        # Execute request and get response as JSON

        response = requests.post(url, data=data, headers={ "x-api-key": API_KEY })
        if (response.status_code == 200):
            json = response.json()

            if json["error"] == False:
                #  Get URL of result file
                resultFileUrl = json["url"]            
                # Download result file
                r = requests.get(resultFileUrl, stream=True)
                if (r.status_code == 200):
                    with open(destinationFile, 'wb') as file:
                        for chunk in r:
                            file.write(chunk)
                    print(f"Result file saved as \"{destinationFile}\" file.")
                else:
                    print(f"Request error: {response.status_code} {response.reason}")
            else:
                # Show service reported error
                print(json["message"])
        else:
            print(f"Request error: {response.status_code} {response.reason}")

    if __name__ == '__main__':
        main()
    ```
  </Tab>

  <Tab title="C#">
    ```csharp theme={null}
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Net.Http;
    using System.Threading.Tasks;
    using Newtonsoft.Json;
    using Newtonsoft.Json.Linq;


    namespace PDFcoCodeSample
    {
        class Program
        {
            const String API_KEY = "***********************************";
            const string DestinationFile = @".\newDocument.pdf";
            const bool Async = true; // Enable asynchronous processing


            static async Task Main(string[] args)
            {
                using (HttpClient httpClient = new HttpClient())
                {
                    httpClient.DefaultRequestHeaders.Add("x-api-key", API_KEY);


                    string url = "https://api.pdf.co/v1/pdf/convert/from/html";


                    // Prepare requests params as JSON
                    Dictionary<string, object> parameters = new Dictionary<string, object>
                    {
                        { "templateId", 1 },
                        { "name", Path.GetFileName(DestinationFile) },
                        { "margins", "40px 20px 20px 20px" },
                        { "paperSize", "Letter" },
                        { "orientation", "Portrait" },
                        { "header", "" },
                        { "printBackground", true },
                        { "footer", "" },
                        { "async", Async }, // Enable asynchronous processing
                        { "encrypt", false },
                        { "templateData", "{\"paid\": true,\"invoice_id\": \"0021\",\"invoice_date\": \"August 29, 2041\",\"invoice_dateDue\": \"September 29, 2041\",\"issuer_name\": \"Sarah Connor\",\"issuer_company\": \"T-800 Research Lab\",\"issuer_address\": \"435 South La Fayette Park Place, Los Angeles, CA 90057\",\"issuer_website\": \"www.example.com\",\"issuer_email\": \"info@example.com\",\"client_name\": \"Cyberdyne Systems\",\"client_company\": \"Cyberdyne Systems\",\"client_address\": \"18144 El Camino Real, Sunnyvale, California\",\"client_email\": \"sales@example.com\",\"items\": [    {    \"name\": \"T-800 Prototype Research\", \"price\": 1000.00    },   {     \"name\": \"T-800 Cloud Sync Setup\", \"price\": 300.00     }  ],\"discount\": 100,\"tax\": 87,\"total\": 1287,\"note\": \"Thank you for your support of advanced robotics.\"}" }
                    };


                    // Convert dictionary of params to JSON
                    string jsonPayload = JsonConvert.SerializeObject(parameters);


                    try
                    {
                        // Send POST request asynchronously
                        var content = new StringContent(jsonPayload, System.Text.Encoding.UTF8, "application/json");
                        HttpResponseMessage response = await httpClient.PostAsync(url, content);


                        // Read response asynchronously
                        string responseBody = await response.Content.ReadAsStringAsync();
                        JObject json = JObject.Parse(responseBody);


                        if (json["error"].ToObject<bool>() == false)
                        {
                            // Get Job ID for asynchronous processing
                            string jobId = json["jobId"].ToString();
                            Console.WriteLine($"Job ID: {jobId}");


                            // Check job status in a loop
                            bool isJobCompleted = false;
                            while (!isJobCompleted)
                            {
                                string status = await CheckJobStatusAsync(httpClient, jobId);
                                Console.WriteLine($"Job Status: {status}");


                                if (status == "success")
                                {
                                    // Get URL of generated PDF file
                                    string resultFileUrl = json["url"].ToString();


                                    // Download PDF file asynchronously
                                    byte[] fileBytes = await httpClient.GetByteArrayAsync(resultFileUrl);
                                    await File.WriteAllBytesAsync(DestinationFile, fileBytes);


                                    Console.WriteLine("Generated PDF file saved as \"{0}\" file.", DestinationFile);
                                    isJobCompleted = true;
                                }
                                else if (status == "working")
                                {
                                    // Wait for a few seconds before checking again
                                    await Task.Delay(3000);
                                }
                                else
                                {
                                    Console.WriteLine($"Job failed or aborted. Status: {status}");
                                    isJobCompleted = true;
                                }
                            }
                        }
                        else
                        {
                            Console.WriteLine(json["message"].ToString());
                        }
                    }
                    catch (Exception e)
                    {
                        Console.WriteLine(e.ToString());
                    }
                }


                Console.WriteLine();
                Console.WriteLine("Press any key...");
                Console.ReadKey();
            }


            static async Task<string> CheckJobStatusAsync(HttpClient httpClient, string jobId)
            {
                string url = $"https://api.pdf.co/v1/job/check?jobid={jobId}";


                // Send GET request to check job status
                HttpResponseMessage response = await httpClient.GetAsync(url);
                string responseBody = await response.Content.ReadAsStringAsync();
                JObject json = JObject.Parse(responseBody);


                return json["status"].ToString();
            }
        }
    }
    ```
  </Tab>

  <Tab title="Java">
    ```java theme={null}
    package com.company;

    import com.google.gson.JsonObject;
    import com.google.gson.JsonParser;
    import com.google.gson.JsonPrimitive;
    import okhttp3.*;

    import java.io.*;
    import java.net.*;
    import java.nio.file.Files;
    import java.nio.file.Path;
    import java.nio.file.Paths;

    public class Main
    {
        // The authentication key (API Key).
        // Get your own by registering at https://app.pdf.co
        final static String API_KEY = "***********************************";


        public static void main(String[] args) throws IOException
        {
            /* 
                Please follow below steps to create your own HTML Template and get "templateId". 
                1. Add new html template in app.pdf.co/templates/html
                2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/bytescout/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
                3. Save this new template
                4. Copy it’s ID to clipboard
                5. Now set ID of the template into “templateId” parameter
            */

            // HTML template using built-in template
            // see https://app.pdf.co/templates/html/2/edit
            final String templateId = "2";
            
            // Data to fill the template
            final String templateData = new String(Files.readAllBytes(Paths.get(".\\invoice_data.json")));
            // Destination PDF file name
            final Path destinationFile = Paths.get(".\\result.pdf");

            // Create HTTP client instance
            OkHttpClient webClient = new OkHttpClient();

            // Prepare URL for `HTML to PDF` API call
            String query = String.format(
                    "https://api.pdf.co/v1/pdf/convert/from/html?name=%s",
                    destinationFile.getFileName());

            // Make correctly escaped (encoded) URL
            URL url = null;
            try
            {
                url = new URI(null, query, null).toURL();
            }
            catch (URISyntaxException e)
            {
                e.printStackTrace();
            }

            // Prepare request body in JSON format
            JsonObject jsonBody = new JsonObject();
            jsonBody.add("templateId", new JsonPrimitive(templateId));
            jsonBody.add("templateData", new JsonPrimitive(templateData));

            RequestBody body = RequestBody.create(MediaType.parse("application/json"), jsonBody.toString());

            // Prepare request
            Request request = new Request.Builder()
                    .url(url)
                    .addHeader("x-api-key", API_KEY) // (!) Set API Key
                    .addHeader("Content-Type", "application/json")
                    .post(body)
                    .build();
            // Execute request
            Response response = webClient.newCall(request).execute();

            if (response.code() == 200)
            {
                // Parse JSON response
                JsonObject json = new JsonParser().parse(response.body().string()).getAsJsonObject();

                boolean error = json.get("error").getAsBoolean();
                if (!error)
                {
                    // Get URL of generated PDF file
                    String resultFileUrl = json.get("url").getAsString();

                    // Download PDF file
                    downloadFile(webClient, resultFileUrl, destinationFile.toFile());

                    System.out.printf("Generated PDF file saved as \"%s\" file.", destinationFile.toString());
                }
                else
                {
                    // Display service reported error
                    System.out.println(json.get("message").getAsString());
                }
            }
            else
            {
                // Display request error
                System.out.println(response.code() + " " + response.message());
            }
        }

        public static void downloadFile(OkHttpClient webClient, String url, File destinationFile) throws IOException
        {
            // Prepare request
            Request request = new Request.Builder()
                    .url(url)
                    .build();
            // Execute request
            Response response = webClient.newCall(request).execute();

            byte[] fileBytes = response.body().bytes();

            // Save downloaded bytes to file
            OutputStream output = new FileOutputStream(destinationFile);
            output.write(fileBytes);
            output.flush();
            output.close();

            response.close();
        }
    }
    ```
  </Tab>

  <Tab title="PHP">
    ```php theme={null}
    <!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>PDF Invoice Generation Results</title>
    </head>
    <body>

    <?php 

    // Get submitted form data
    $apiKey = $_POST["apiKey"]; // The authentication key (API Key). Get your own by registering at https://app.pdf.co

    // Prepare URL for HTML to PDF API call
    $url = "https://api.pdf.co/v1/pdf/convert/from/html";

    // Prepare requests params
    $parameters = array();
    $parameters["name"] = "result.pdf";

    /* 
    Please follow below steps to create your own HTML Template and get "templateId". 
    1. Add new html template in app.pdf.co/templates/html
    2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/bytescout/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
    3. Save this new template
    4. Copy it’s ID to clipboard
    5. Now set ID of the template into “templateId” parameter
    */

    // HTML template using built-in template
    // see https://app.pdf.co/templates/html/1/edit
    $parameters["templateId"] = 1;

    // Data to fill the template
    $templateData = file_get_contents("./invoice_data.json");
    $parameters["templateData"] = $templateData;

    // Create Json payload
    $data = json_encode($parameters);

    // Create request
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "Content-type: application/json"));
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

    // Execute request
    $result = curl_exec($curl);

    if (curl_errno($curl) == 0)
    {
        $status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        
        if ($status_code == 200)
        {
            $json = json_decode($result, true);
            
            if (!isset($json["error"]) || $json["error"] == false)
            {
                $resultFileUrl = $json["url"];
                
                // Display link to the file with conversion results
                echo "<div><h2>Conversion Result:</h2><a href='" . $resultFileUrl . "' target='_blank'>" . $resultFileUrl . "</a></div>";
            }
            else
            {
                // Display service reported error
                echo "<p>Error: " . $json["message"] . "</p>"; 
            }
        }
        else
        {
            // Display request error
            echo "<p>Status code: " . $status_code . "</p>"; 
            echo "<p>" . $result . "</p>";
        }
    }
    else
    {
        // Display CURL error
        echo "Error: " . curl_error($curl);
    }

    // Cleanup
    curl_close($curl);


    ?>

    </body>
    </html>
    ```
  </Tab>
</Tabs>
